<?php
/**
 * We offer the best and most useful modules PrestaShop and modifications for your online store.
 *
 * We are experts and professionals in PrestaShop
 *
 * Prestashop module for Oct8ne
 *
 * @author    PresTeamShop.com <support@presteamshop.com>
 * @copyright 2011-2019 PresTeamShop
 * @license   Commercial license see license.txt
 * @category  PrestaShop
 * @category  Module
 */

require_once dirname(__FILE__) . '/AbstractSearchEngine.php';

/**
 * Implementacion especifica de empathybroker
 * Class OctEmpathybrokerSearch
 */
class OctEmpathybrokerSearch extends AbstractSearchEngine
{
    function doSearch($language, $search, $page, $pageSize, $orderBy, $dir)
    {
        $iso_code = Language::getIsoById($language);

        $curl = curl_init();
        
        $url = Configuration::get(Oct8ne::$URL_API_EMPATHYBROKER).$search.'&lang='.$iso_code.'&page='.$page;

        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);

        $output = curl_exec($curl);

        curl_close($curl);

        $result = Tools::jsonDecode($output);

        $total = (int)$result->content->numFound;
        $products = array();
        if (is_array($result->content->docs) && count($result->content->docs) > 0) {
            foreach ($result->content->docs as $item) {
                $query = new DbQuery();
                $query->select('p.id_product');
                $query->from('product', 'p');
                $query->where('p.reference = \''.pSQL($item->id).'\'');

                $id_product = (int)Db::getInstance(_PS_USE_SQL_SLAVE_)->getValue($query);

                if (!empty($id_product)) {
                    $product = array(
                        'id_product' => $id_product
                    );

                    $products[] = $product;
                }
            }
        }

        return array(
            'total' => $total,
            'result' => $products
        );
    }
}